Index: apps/app_senddtmf.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_senddtmf.c,v
retrieving revision 1.7
diff -u -r1.7 app_senddtmf.c
--- apps/app_senddtmf.c	22 Jun 2004 19:32:52 -0000	1.7
+++ apps/app_senddtmf.c	29 Dec 2004 20:10:47 -0000
@@ -31,7 +31,7 @@
 static char *synopsis = "Sends arbitrary DTMF digits";
 
 static char *descrip = 
-"  SendDTMF(digits): Sends DTMF digits on a channel. \n"
+"  SendDTMF(digits[|timeout_ms]): Sends DTMF digits on a channel. \n"
 "  Accepted digits: 0-9, *#abcd\n"
 " Returns 0 on success or -1 on a hangup.\n";
 
@@ -43,15 +43,26 @@
 {
 	int res = 0;
 	struct localuser *u;
-	char *digits = data;
+	char *digits = NULL, *to = NULL;
+	int timeout = 250;
 
-	if (!digits || ast_strlen_zero(digits)) {
-		ast_log(LOG_WARNING, "SendDTMF requires an argument (digits or *#aAbBcCdD)\n");
-		return -1;
+	if((digits = ast_strdupa((char *)data))) {
+		if((to = strchr(digits,'|'))) {
+			*to = '\0';
+			to++;
+			timeout = atoi(to);
+		}
+		if (!digits || ast_strlen_zero(digits)) {
+			ast_log(LOG_WARNING, "SendDTMF requires an argument (digits or *#aAbBcCdD)\n");
+			return -1;
+		}
+		LOCAL_USER_ADD(u);
+		if(timeout <= 0)
+			timeout = 250;
+
+		res = ast_dtmf_stream(chan,NULL,digits,timeout);
+		LOCAL_USER_REMOVE(u);
 	}
-	LOCAL_USER_ADD(u);
-	res = ast_dtmf_stream(chan,NULL,digits,250);
-	LOCAL_USER_REMOVE(u);
 	return res;
 }
 
